%define anolis_release 2

# we don't have firefox now
%bcond_with firefox

%global major_version %(echo -n %{version} | sed 's/[.].*//')

%global gettext_version                         0.19.6
%global glib2_version                           2.68.0
%global gtk4_version                            3.24.27
%global ibus_version                            1.5.24
%global mutter_version                          44~beta
%global gnome_desktop_version                   40~rc
%global gsettings_desktop_schemas_version       40~rc
%global gnome_settings_daemon_version           40~rc

Name:           gnome-kiosk
Version:        44.0
Release:        %{anolis_release}%{?dist}
Summary:        Window management and application launching for GNOME

License:        GPLv2+
URL:            https://gitlab.gnome.org/GNOME/gnome-kiosk
Source0:        https://download.gnome.org/sources/gnome-kiosk/%{major_version}/%{name}-%{version}.tar.xz

Provides:       firstboot(windowmanager) = %{name}

BuildRequires:  dconf gcc meson gettext >= %{gettext_version}
BuildRequires:  mesa-libEGL-devel mesa-libGL-devel
BuildRequires:  pkgconfig(ibus-1.0) >= %{ibus_version} pkgconfig(libmutter-12) >= %{mutter_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0) >= %{gnome_desktop_version} pkgconfig(gtk4) >= %{gtk4_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib2_version} pkgconfig(gio-2.0) >= %{glib2_version} 
BuildRequires:  pkgconfig(gobject-2.0) >= %{glib2_version}

Requires: 	gsettings-desktop-schemas >= %{gsettings_desktop_schemas_version}
Requires:       gnome-settings-daemon >= %{gnome_settings_daemon_version}

%if ! %{with firefox}
Obsoletes:	gnome-kiosk-search-appliance < %{version}-%{release}
%endif

%description
GNOME Kiosk provides a desktop environment suitable for fixed purpose, or
single application deployments like wall displays and point-of-sale systems.

It provides a very minimal wayland display server and compositor and Xorg
compositor and window manager. It automatically starts applications fullscreen.

Notably, GNOME Kiosk features no panels, dashes, or docks that could distract
from the application using it as a platform.

%if %{with firefox}
%package search-appliance
Summary:        Example search application application that uses GNOME Kiosk
License:        GPLv2+
Requires:       %{name} = %{version}-%{release}
Requires:       firefox gnome-session
BuildArch:      noarch

%description search-appliance
This package provides a full screen firefox window pointed to google.
%endif

%package script-session
Summary:        Basic session used for running kiosk application from shell script
License:        GPLv2+
Requires:       %{name} = %{version}-%{release}
Recommends:     gedit
Requires:       gnome-session
BuildArch:      noarch

%description script-session
This package generates a shell script and the necessary scaffolding to start that shell script within a kiosk session.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%meson
%meson_build

%install
%meson_install

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/org.gnome.Kiosk.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop

%files
%license COPYING
%{_bindir}/gnome-kiosk
%{_datadir}/applications/org.gnome.Kiosk.desktop
%{_datadir}/dconf/profile/gnomekiosk
%{_datadir}/gnome-kiosk/gnomekiosk.dconf.compiled
%{_userunitdir}/org.gnome.Kiosk.target
%{_userunitdir}/org.gnome.Kiosk@wayland.service
%{_userunitdir}/org.gnome.Kiosk@x11.service

%if %{with firefox}
%files search-appliance
%{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop
%{_datadir}/gnome-session/sessions/org.gnome.Kiosk.SearchApp.session
%{_datadir}/xsessions/org.gnome.Kiosk.SearchApp.Session.desktop
%{_datadir}/wayland-sessions/org.gnome.Kiosk.SearchApp.Session.desktop
%else
%exclude %{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop
%exclude %{_datadir}/gnome-session/sessions/org.gnome.Kiosk.SearchApp.session
%exclude %{_datadir}/xsessions/org.gnome.Kiosk.SearchApp.Session.desktop
%exclude %{_datadir}/wayland-sessions/org.gnome.Kiosk.SearchApp.Session.desktop
%endif

%files script-session
%{_bindir}/gnome-kiosk-script
%{_userunitdir}/gnome-session@gnome-kiosk-script.target.d/session.conf
%{_userunitdir}/org.gnome.Kiosk.Script.service
%{_datadir}/applications/org.gnome.Kiosk.Script.desktop
%{_datadir}/gnome-session/sessions/gnome-kiosk-script.session
%{_datadir}/wayland-sessions/gnome-kiosk-script-wayland.desktop
%{_datadir}/xsessions/gnome-kiosk-script-xorg.desktop

%files doc
%doc NEWS README.md

%changelog
* Sat May 06 2023 happy_orange <songnannan@linux.alibaba.com> - 44.0-2
- add obsoletes the firefox package

* Wed Apr 12 2023 yuanhui <yuanhui@linux.alibaba.com> - 44.0-1
- Optimize the spec file
- Update to 44.0

* Mon Mar 20 2023 yuanhui <yuanhui@linux.alibaba.com> - 44~rc-2
- Rebuild with gnome-desktop3-44~beta

* Fri Mar 17 2023 yuanhui <yuanhui@linux.alibaba.com> - 44~rc-1
- Update to 44~rc
- Add doc package

* Tue Feb 21 2023 Funda Wang <fundawang@yeah.net> - 42.0-2
- Fix build with upstream patch

* Wed Apr 13 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 42.0-1
- Init from upstream version 42.0

